﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;

namespace NauPlaying
{
	/// <summary>
	/// ボードデータ
	/// </summary>
	public class BoardData
	{
		/// <summary>
		/// 表示テキスト
		/// </summary>
		public string Text { set; get; }
		/// <summary>
		/// 表示アートワーク
		/// </summary>
		public Bitmap Artwork { set; get; }

		/// <summary>
		/// 標準のコンストラクタ
		/// </summary>
		public BoardData()
		{
			Text = "";
			Artwork = null;
		}

		/// <summary>
		/// パラメータを指定するコンストラクタ
		/// </summary>
		/// <param name="text">表示テキスト</param>
		/// <param name="artwork">表示アートワーク</param>
		public BoardData(string text, Bitmap artwork)
		{
			Text = text;
			Artwork = artwork;
		}

		/// <summary>
		/// ディープコピー
		/// </summary>
		/// <returns></returns>
		public BoardData DeepCopy()
		{
			BoardData obj = new BoardData();

			obj.Text = Text;

			if(Artwork != null)
				obj.Artwork = new Bitmap(Artwork);

			return obj;
		}
	}
}
