﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NauPlaying
{
	/// <summary>
	/// 色選択コントロールクラス
	/// </summary>
	public partial class ColorSelectBox : UserControl
	{
		/// <summary>
		/// Color の取得、設定
		/// （実際には BackColor プロパティ）
		/// </summary>
		public Color Color
		{
			set { BackColor = value; }
			get { return BackColor; }
		}

		/// <summary>
		/// 標準のコンストラクタ
		/// </summary>
		public ColorSelectBox()
		{
			InitializeComponent();
		}

		/// <summary>
		/// マウスイベント：クリック
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ColorSelectBox_MouseClick(object sender, MouseEventArgs e)
		{
			if(e.Button == System.Windows.Forms.MouseButtons.Left)
			{
				ColorDialog dlg = new ColorDialog();

				dlg.Color = Color;
				dlg.FullOpen = true;

				if(dlg.ShowDialog() == DialogResult.OK)
				{
					Color = dlg.Color;
				}
			}
		}

		/// <summary>
		/// マウスイベント：移動
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ColorSelectBox_MouseMove(object sender, MouseEventArgs e)
		{
			// カーソルの変更
			Cursor = Cursors.Hand;
		}
	}
}
