﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Win32SDK;

namespace NauPlaying
{
	/// <summary>
	/// 位置変更用フォーム
	/// </summary>
	public partial class FormPositioner : Form
	{
		public FormPositioner()
		{
			InitializeComponent();
		}

		/// <summary>
		/// ウインドウメッセージのトラップ
		/// </summary>
		/// <param name="m"></param>
		protected override void WndProc(ref Message m)
		{
			// ダブルクリックによる最大化の抑制
			if(m.Msg == Win32.WM_NCLBUTTONDBLCLK)
			{
				DialogResult = System.Windows.Forms.DialogResult.OK;
				Close();
				return;
			}
			
			base.WndProc(ref m);

			// どこをつかんでも移動できるようにする
			if((m.Msg == Win32.WM_NCHITTEST) && (m.Result.ToInt32() == User32.HTCLIENT))
			{
				m.Result = (IntPtr)User32.HTCAPTION;
			}
		}

		protected override bool ProcessDialogKey(Keys keyData)
		{
			switch(keyData)
			{
			case Keys.Escape:
				DialogResult = System.Windows.Forms.DialogResult.Cancel;
				Close();
				return false;

			case Keys.Return:
				DialogResult = System.Windows.Forms.DialogResult.OK;
				Close();
				return false;
			}
			return true;
		}
	}
}
