﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace NauPlaying
{
	public class EditorFileOpen : System.Drawing.Design.UITypeEditor
	{
		// ファイルオープンダイアログ
		private OpenFileDialog _ofd = null;

		// 編集スタイルの取得
		public override System.Drawing.Design.UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
		{
			return System.Drawing.Design.UITypeEditorEditStyle.Modal;
		}

		// 値の編集
		public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			IWindowsFormsEditorService editservice = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

			if(_ofd == null)
			{
				_ofd = new OpenFileDialog();

				_ofd.Filter = "Bitmap files (*.bmp)|*.bmp|Jpeg files (*.jpg)|*.jpg|" + "PNG files (*.png)|*.png|all files (*.*)|*.*";
				_ofd.CheckFileExists = true;
			}

			_ofd.FileName = value as string;

			if(_ofd.ShowDialog() == DialogResult.OK)
				return _ofd.FileName;
			else
				return value;
		}
	}
}