﻿using System;
using System.Collections.Generic;
using System.Text;

using System.IO;

namespace NTag
{
	/// <summary>
	/// グを読み込むクラスのインターフェース
	/// </summary>
	public interface ITagReader
	{
		/// <summary>
		/// タグデータ
		/// </summary>
		Tag Tag { get; }

		/// <summary>
		/// タグを読み込むファイルのパスの取得
		/// </summary>
		string FilePath { get; }

		/// <summary>
		/// 有効なファイルであるかを確認します
		/// </summary>
		/// <returns></returns>
		bool IsValidFile();
		
		/// <summary>
		/// タグ読み込みます
		/// </summary>
		/// <param name="filePath">読み込むファイル名</param>
		void Read();
	}
}
