﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NTag.MP4.Atom
{
	/// <summary>
	/// 共通の処理、定数のクラス
	/// </summary>
	public static class Atom
	{
		/// <summary>
		/// 使用するアトム名一覧
		/// </summary>
		public static readonly Dictionary<NTag.TagFieldFlags, byte[]> ATOM_NAME_TABLE = new Dictionary<NTag.TagFieldFlags, byte[]>
		{
			{ NTag.TagFieldFlags.Title, new byte[4] { 0xA9, 0x6E, 0x61, 0x6D } },			// ｩnam - Title
			{ NTag.TagFieldFlags.Artist, new byte[4] { 0xA9, 0x41, 0x52, 0x54 } },			// ｩART - Artist
			{ NTag.TagFieldFlags.Album, new byte[4] { 0xA9, 0x61, 0x6c, 0x62 } },			// ｩalb - Album
			{ NTag.TagFieldFlags.Genre, new byte[4] { 0xA9, 0x67, 0x65, 0x6e } },			// ｩgen - Genre
			{ NTag.TagFieldFlags.Year, new byte[4] { 0xA9, 0x64, 0x61, 0x79 } },			// ｩday - Year
			{ NTag.TagFieldFlags.Comment, new byte[4] { 0xA9, 0x63, 0x6d, 0x74 } },			// ｩcmt - Comment
			{ NTag.TagFieldFlags.TrackNumber1, new byte[4] { 0x74, 0x72, 0x6b, 0x6e } },	// trkn - Track number
			{ NTag.TagFieldFlags.Artwork, new byte[4] { 0x63, 0x6f, 0x76, 0x72 } },			// covr - Artwork
		};

		/// <summary>
		/// NULL スペース
		/// </summary>
		public static readonly byte[] NULL_ATOMNAME = { 0, 0, 0, 0 };

		/// <summary>
		/// ilst アトム名
		/// </summary>
		public static readonly byte[] ILST_ATOMNAME = { 0x69, 0x6c, 0x73, 0x74 };	// ilst
		/// <summary>
		/// data アトム名
		/// </summary>
		public static readonly byte[] DATA_ATOMNAME = { 0x64, 0x61, 0x74, 0x61 };	// data
	}
}
