﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NTag.MP4.Atom
{
	/// <summary>
	/// アトムの基本クラス
	/// （基本これで全て読める）
	/// </summary>
	class AtomBasic
	{
		/// <summary>
		/// アトムヘッダ
		/// </summary>
		public AtomHeader Header { set; get; }

		/// <summary>
		/// アトムデータデータサイズ
		/// </summary>
		public int AtomDataSize { set; get; }

		/// <summary>
		/// アトムデータ
		/// </summary>
		public byte[] Data { set; get; }

		/// <summary>
		/// コンストラクタ
		/// </summary>
		public AtomBasic()
		{
			Header = new AtomHeader();
			Data = null;
		}

		/// <summary>
		/// アトムを読み込む
		/// </summary>
		/// <param name="data"></param>
		/// <param name="offset"></param>
		/// <returns></returns>
		public int Read(byte[] data, int offset)
		{
			int readBytes = 0;

			// ヘッダ読込み 8byte
			readBytes = Header.ReadHeader(data, offset);

			// アトムのデータから ヘッダ分 8 byte 引いた分がデータ
			AtomDataSize = Header.Size - readBytes;

			Data = new byte[AtomDataSize];
			Buffer.BlockCopy(data, offset + readBytes, Data, 0, AtomDataSize);

			return Header.Size;
		}

		/// <summary>
		/// 子アトムを内包しているかを調べる
		/// </summary>
		/// <returns></returns>
		public bool IsHaveChild()
		{
			AtomHeader header = new AtomHeader();
			header.ReadHeader(Data, 0);

			if(header.IsNullAtomName())
				return false;

			return true;
		}
	}
}
