﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

using System.Drawing;
using System.IO;
using System.Threading;
using System.Reflection;

using Win32SDK;

namespace NauPlaying
{
	static class Program
	{
		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main()
		{
			// 2重起動の防止
			using(Mutex mutex = new Mutex(false, Application.ProductName))
			{
				// 失敗した場合はすでに起動している
				if(!mutex.WaitOne(0, false))
					return;

				// アプリの起動処理
				Application.EnableVisualStyles();
				Application.SetCompatibleTextRenderingDefault(false);

				try
				{
					FormMain formMain = new FormMain();
					Application.Run(formMain);
				}
				catch(Exception)
				{
				}

				// ミューテックスの開放
				GC.KeepAlive(mutex);
				mutex.ReleaseMutex();
			}
		}
	}
}
