﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;

namespace NauPlaying.Skin
{
	/// <summary>
	/// 表示更新情報クラス
	/// </summary>
	public class DrawingInfo
	{
		/// <summary>
		/// アルファ値 不透明:1 ～ 透明:0
		/// </summary>
		public float Alpha { set; get; }
		/// <summary>
		/// ズーム倍率
		/// </summary>
		public float Magnification { set; get; }
		/// <summary>
		/// 表示位置の左上座標
		/// </summary>
		public Point Location { set; get; }
		/// <summary>
		/// テキストのコピー元位置
		/// </summary>
		public int TextSrcPos { set; get; }

		/// <summary>
		/// 標準のコンストラクタ
		/// </summary>
		public DrawingInfo()
		{
			Alpha = 1.0f;
			Magnification = 1.0f;
			Location = new Point();
			TextSrcPos = 0;
		}

		/// <summary>
		/// ディープコピー
		/// </summary>
		/// <returns></returns>
		public DrawingInfo DeepCopy()
		{
			DrawingInfo obj = (DrawingInfo)MemberwiseClone();
			return obj;
		}
	}
}
