﻿using System;
using System.Drawing;
using System.Text;

using System.Runtime.InteropServices;

namespace Win32SDK
{
	internal static class Ole32
	{
		public const int S_OK = 0;
		public const int CLSCTX_LOCAL_SERVER = 4;
		public const int CLSCTX_INPROC_SERVER = 1;
		public const int CLSCTX_INPROC_HANDLER = 2;
		public const int CLSCTX_SERVER = CLSCTX_INPROC_SERVER | CLSCTX_LOCAL_SERVER;
		public const int FELANG_REQ_REV = 0x00030000;
		public const int FELANG_CMODE_PINYIN = 0x00000100;
		public const int FELANG_CMODE_NOINVISIBLECHAR = 0x40000000;

		
		public static int CLSIDFromString([MarshalAs(UnmanagedType.LPWStr)] string lpsz, out Guid pclsid)
		{ return NativeMethods.CLSIDFromString(lpsz, out pclsid); }

		public static int CoCreateInstance([MarshalAs(UnmanagedType.LPStruct)] Guid rclsid,
			IntPtr pUnkOuter, uint dwClsContext, [MarshalAs(UnmanagedType.LPStruct)] Guid riid, out IntPtr rpv)
		{ return NativeMethods.CoCreateInstance(rclsid, pUnkOuter, dwClsContext, riid, out rpv); }

		public static int CoInitialize(IntPtr pvReserved)
		{ return NativeMethods.CoInitialize(pvReserved); }

		public static int CoUninitialize()
		{ return NativeMethods.CoUninitialize(); }

		/// <summary>
		/// NativeMethods ネイティブコードを呼び出す内部クラス
		/// </summary>
		internal static class NativeMethods
		{
			[DllImport("ole32.dll", SetLastError = true, ExactSpelling = true)]
			public static extern int CLSIDFromString([MarshalAs(UnmanagedType.LPWStr)] string lpsz, out Guid pclsid);

			[DllImport("ole32.dll", SetLastError = true, ExactSpelling = true)]
			public static extern int CoCreateInstance([MarshalAs(UnmanagedType.LPStruct)] Guid rclsid,
				IntPtr pUnkOuter, uint dwClsContext, [MarshalAs(UnmanagedType.LPStruct)] Guid riid, out IntPtr rpv);

			[DllImport("ole32.dll", SetLastError = true, ExactSpelling = true)]
			public static extern int CoInitialize(IntPtr pvReserved);

			[DllImport("ole32.dll", SetLastError = true, ExactSpelling = true)]
			public static extern int CoUninitialize();
		}
	}
}
