﻿using System;
using System.Drawing;
using System.Text;

using System.Runtime.InteropServices;

namespace Win32SDK
{
	internal static class Win32
	{
		/// <summary>
		/// WM_QUERYENDSESSIONメッセージの結果として全てのトップレベルウィンドウに送られる。
		/// このメッセージはセッションが実際に終了するかどうかをアプリケーションに知らせる。
		/// </summary>
		public static int WM_ENDSESSION = 0x0016;

		/// <summary>
		/// 非クライアント領域内において、マウスの右ボタンが押されたときに送られる
		/// </summary>
		public static int WM_NCMOUSEMOVE = 0x000000a0;
		/// <summary>
		/// 非クライアント領域内において、マウスの左ボタンが押されたときに送られる
		/// </summary>
		public static int WM_NCLBUTTONDOWN = 0x000000a1;
		/// <summary>
		/// 非クライアント領域内において、マウスの右ボタンが離されたときに送られる
		/// </summary>
		public static int WM_NCRBUTTONUP = 0x000000a2;
		/// <summary>
		/// 非クライアント領域内でマウスの左ボタンがダブルクリックされたとき
		/// </summary>
		public static int WM_NCLBUTTONDBLCLK = 0x000000a3;
		/// <summary>
		/// 非クライアント領域内において、マウスの右ボタンが押されたときに送られる
		/// </summary>
		public static int WM_NCRBUTTONDOWN = 0x000000a4;
		/// <summary>
		/// 非クライアント領域内において、マウスの右ボタンがダブルクリックされたときに送られる
		/// </summary>
		public static int WM_NCRBUTTONDBCLK = 0x000000a6;

		/// <summary>
		/// マウスポインタの指定の位置を調べるときに送る
		/// </summary>
		public static int WM_NCHITTEST = 0x0084;

		/// <summary>
		/// キーダウンイベント
		/// </summary>
		public const int WM_KEYDOWN = 0x00000100;
		/// <summary>
		/// キーアップイベント
		/// </summary>
		public const int WM_KEYUP = 0x00000101;
		/// <summary>
		/// システムキーダウンイベント
		/// </summary>
		public const int WM_SYSKEYDOWN = 0x00000104;
		/// <summary>
		/// システムキーアップイベント
		/// </summary>
		public const int WM_SYSKEYUP = 0x00000105;
		/// <summary>
		/// システムメニュー（コントロールメニュー）のアイテムが選択された場合や、
		/// ウィンドウ右上の「最大化」「最小化」「元のサイズに戻す」「閉じる」ボタンが押された場合に、ウィンドウに送信されます
		/// </summary>
		public static int WM_SYSCOMMAND = 0x0112;

		/// <summary>
		/// マウスカーソルが移動した場合に送られる。
		/// </summary>
		public static int WM_MOUSEMOVE = 0x0200;
	}	
}
