﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PluginBase
{
	/// <summary>
	/// プラグインタイプ
	/// </summary>
	public enum PluginType
	{
		/// <summary>
		/// アプリケーションモニタープラグイン
		/// </summary>
		AppMonitor,
	}

	/// <summary>
	/// すべてのプラグイン共通のインターフェース
	/// </summary>
	public interface IPlugin
	{
		#region /* プロパティ */

		/// <summary>
		/// プラグインタイプの取得
		/// </summary>
		PluginType MyPluginType { get; }

		/// <summary>
		/// プラグイン名の取得
		/// </summary>
		string PluginName { get; }
		/// <summary>
		/// プラグインの著作権の取得
		/// </summary>
		string Copyright { get; }

		#endregion
	}
}
