#include "StdAfx.h"

#include <tchar.h>
#include <memory>

#include "Winamp.h"

#include "wa_dlg.h"
#include "wa_ipc.h"

#pragma comment(lib, "user32.lib")
#pragma comment(lib, "kernel32.lib")

// frontend.h Ă̂ŌÂRs[
#define WINAMP_BUTTON1                  40044
#define WINAMP_BUTTON2                  40045
#define WINAMP_BUTTON3                  40046
#define WINAMP_BUTTON4                  40047
#define WINAMP_BUTTON5                  40048
#define WINAMP_BUTTON1_SHIFT            40144
#define WINAMP_BUTTON2_SHIFT            40145
#define WINAMP_BUTTON3_SHIFT            40146
#define WINAMP_BUTTON4_SHIFT            40147
#define WINAMP_BUTTON5_SHIFT            40148
#define WINAMP_BUTTON1_CTRL             40154
#define WINAMP_BUTTON2_CTRL             40155
#define WINAMP_BUTTON3_CTRL             40156
#define WINAMP_BUTTON4_CTRL             40157
#define WINAMP_BUTTON5_CTRL             40158

// ^f[^擾̍ۂ̎w蕶
#define METAFIELD_STRING_TRACKNAME		"title"
#define METAFIELD_STRING_ALBUM			"album"
#define METAFIELD_STRING_ARTIST			"artist"
#define METAFIELD_STRING_YEAR			"year"
#define METAFIELD_STRING_GENRE			"genre"
#define METAFIELD_STRING_TRACKNUMBER	"track"
#define METAFIELD_STRING_LENGTH			"length"
#define METAFIELD_STRING_COMMENT		"comment"

/// <summary>
/// Winamp ̃EChEL𒲂ׂ
/// </summary>
HWND Winamp::FindWinamp()
{
	// v1.x  v2.0ȍ~łĂ݊̂߂ v1.x ł̂ŒĂB
	HWND hWnd = ::FindWindow(_T("Winamp v1.x"), NULL);

	return hWnd;
}

/// <summary>
/// Đ𒲂ׂ (true ōĐ)
/// </summary>
bool Winamp::IsPlaying()
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	int state = (int)::SendMessage(hWnd, WM_WA_IPC, 0, IPC_ISPLAYING);

	switch(state)
	{
	// playing
	case 1:
		return true;
	// paused
	case 3:
		return false;
	// not playing
	case 0:
		return false;
	}

	return false;
}

/// <summary>
/// ꎞ~𒲂ׂ (true ňꎞ~)
/// </summary>
bool Winamp::IsPause()
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	int state = (int)::SendMessage(hWnd, WM_WA_IPC, 0, IPC_ISPLAYING);

	switch(state)
	{
	// playing
	case 1:
		return false;
	// paused
	case 3:
		return true;
	// not playing
	case 0:
		return false;
	}

	return false;
}

/// <summary>
/// ʂ (0 - 100) ͈̔͂Őݒ肷
/// </summary>
bool Winamp::SetSoundVolume(int vol)
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	int _vol = static_cast<int>(static_cast<float>(vol) / 100.0f * 255.0f);
	if(_vol < 0)
		_vol = 0;
	else if(_vol > 255)
		_vol = 255;

	::SendMessage(hWnd, WM_WA_IPC, _vol, IPC_SETVOLUME);

	return true;
}

/// <summary>
/// ʂ (0 - 100) ͈̔͂Ŏ擾
/// </summary>
int Winamp::GetSoundVolume()
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return -1;

	int _vol = ::SendMessage(hWnd, WM_WA_IPC, -666, IPC_SETVOLUME);

	int vol = static_cast<int>(static_cast<float>(_vol) / 255.0f * 100.0f);

	if(vol < 0)
		vol = 0;
	else if(vol > 100)
		vol = 100;

	return vol;
}

/// <summary>
/// Đʒu[s]Őݒ肷B
/// </summary>
bool Winamp::SetPlayerPosition(int pos)
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	::SendMessage(hWnd, WM_WA_IPC, pos * 1000, IPC_JUMPTOTIME);

	return true;
}

/// <summary>
/// Đʒu[s]Ŏ擾B
/// </summary>
int Winamp::GetPlayerPosition()
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return -1;

	return ::SendMessage(hWnd, WM_WA_IPC, 0, IPC_GETOUTPUTTIME) / 1000;
}

/// <summary>
/// Đ̋Ȃ̑tԂ[s]Ŏ擾
/// </summary>
int Winamp::GetPlayingTrackLength()
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return -1;

	return ::SendMessage(hWnd, WM_WA_IPC, 1, IPC_GETOUTPUTTIME);
}

/// <summary>
/// ݑIĂvCXg̃CfbNX擾
/// </summary>
int Winamp::GetPlayListPosition()
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return -1;

	return ::SendMessage(hWnd, WM_WA_IPC, 0, IPC_GETLISTPOS);
}

/// <summary>
/// ĐRg[
/// </summary>
bool Winamp::SendCommandMessase(CTRLWINAMP_COMMAND cmd)
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	// bZ[W̉
	int msg;
	switch(cmd)
	{
	case CTRLWINAMP_COMMAND_SKIP_BEFORE:
		msg = WINAMP_BUTTON1;
		break;
	case CTRLWINAMP_COMMAND_PLAY:
		msg = WINAMP_BUTTON2;
		break;
	case CTRLWINAMP_COMMAND_PAUSE:
		msg = WINAMP_BUTTON3;
		break;
	case CTRLWINAMP_COMMAND_STOP:
		msg = WINAMP_BUTTON4;
		break;
	case CTRLWINAMP_COMMAND_SKIP_NEXT:
		msg = WINAMP_BUTTON5;
		break;
	case CTRLWINAMP_COMMAND_REWIND:
		msg = WINAMP_BUTTON1_SHIFT;
		break;
	case CTRLWINAMP_COMMAND_FILEREAD:
		msg = WINAMP_BUTTON2_SHIFT;
		break;
	case CTRLWINAMP_COMMAND_SHIFT_PAUSE:
		msg = WINAMP_BUTTON3_SHIFT;
		break;
	case CTRLWINAMP_COMMAND_FEEDOUT:
		msg = WINAMP_BUTTON4_SHIFT;
		break;
	case CTRLWINAMP_COMMAND_WIND:
		msg = WINAMP_BUTTON5_SHIFT;
		break;
	case CTRLWINAMP_COMMAND_SKIP_PLAYLIST_TOP:
		msg = WINAMP_BUTTON1_CTRL;
		break;
	case CTRLWINAMP_COMMAND_READFILE_URL:
		msg = WINAMP_BUTTON2_CTRL;
		break;
	case CTRLWINAMP_COMMAND_CTRL_PAUSE:
		msg = WINAMP_BUTTON3_CTRL;
		break;
	case CTRLWINAMP_COMMAND_CTRL_STOP:
		msg = WINAMP_BUTTON4_CTRL;
		break;
	case CTRLWINAMP_COMMAND_SKIP_PLAYLIST_END:
		msg = WINAMP_BUTTON5_CTRL;
		break;
	default:
		return false;
	}

	// bZ[WM
	::SendMessage(hWnd, WM_COMMAND, msg, 0);

	return true;
}

/// <summary>
/// vCXg̃CfbNXw肵āA̋Ȃ̃t@CpX擾
/// </summary>
bool Winamp::GetPlayListFilename(int index, std::string& filepath)
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	const int cbSize = 1024;
	HANDLE hWinampProc = NULL;

	try
	{
		// bZ[WM
		LPVOID lpPlayListFilename = (char*)::SendMessage(hWnd, WM_WA_IPC, index, IPC_GETPLAYLISTFILE);
		if(lpPlayListFilename == NULL)
			return false;

		// Winampւ̃vZXnh擾
		DWORD dwProcessID = 0;
		::GetWindowThreadProcessId(hWnd, &dwProcessID);
		hWinampProc = ::OpenProcess(PROCESS_VM_READ, FALSE, dwProcessID);
		if(hWinampProc == NULL)
			return false;

		// ̓Ǎ
		DWORD dwRead = 0;
		std::auto_ptr<char> pszBuffer(new char[cbSize + 1]);

		if(pszBuffer.get())
		{
			if(::ReadProcessMemory(hWinampProc, lpPlayListFilename, pszBuffer.get(), cbSize, &dwRead) == 0)
				return false;

			filepath = pszBuffer.get();
		}
		else
			return false;

		return true;
	}
	__finally
	{
		// nhJ
		if(hWinampProc)
			::CloseHandle(hWinampProc);
	}
}

/// <summary>
/// ^f[^擾܂
/// </summary>
bool Winamp::GetMetaDataInfo(const std::string& strFileName, METAFIELD field, std::string& metadata)
{
	std::string strField = "";
	switch(field)
	{
	case METAFIELD_TRACKNAME :
		strField = METAFIELD_STRING_TRACKNAME;
		break;
	case METAFIELD_ALBUM :
		strField = METAFIELD_STRING_ALBUM;
		break;
	case METAFIELD_ARTIST :
		strField = METAFIELD_STRING_ARTIST;
		break;
	case METAFIELD_YEAR :
		strField = METAFIELD_STRING_YEAR;
		break;
	case METAFIELD_GENRE :
		strField = METAFIELD_STRING_GENRE;
		break;
	case METAFIELD_TRACKNUMBER :
		strField = METAFIELD_STRING_TRACKNUMBER;
		break;
	case METAFIELD_LENGTH :
		strField = METAFIELD_STRING_LENGTH;
		break;
	case METAFIELD_COMMENT :
		strField = METAFIELD_STRING_COMMENT;
		break;
	default:
		return false;
	}

	return GetMetaDataInfo(strFileName, strField, metadata);
}

/// <summary>
/// ^f[^擾܂
/// </summary>

typedef LPVOID (WINAPI *virtAllocEx)(HANDLE hProcess, LPVOID lpAddress, DWORD dwSize, DWORD flAllocationType, DWORD flProtect);
typedef BOOL (WINAPI *virtFreeEx)(HANDLE hProcess, LPVOID lpAddress, DWORD dwSize, DWORD dwFreeType);

bool Winamp::GetMetaDataInfo(const std::string& strFileName, const std::string& strField, std::string& metadata)
{
	HWND hWnd = FindWinamp();
	if(hWnd == NULL)
		return false;

	const int cbSize = 1024;
	extendedFileInfoStruct extFileStruct;

	// for pointer in Winamp process
	extendedFileInfoStruct* pExtFileStructRemote = NULL;
	char* pszFileNameRemote = NULL;
	char* pszFieldRemote = NULL;
	char* pszBufferRemote = NULL;

	HANDLE hWinampProc = NULL;

	virtAllocEx allocEx = NULL;
	virtFreeEx freeEx = NULL;

	try
	{
		HINSTANCE hKernel = ::GetModuleHandle(_T("kernel32.dll"));
		if(!hKernel)
			return false;

		///////////////////////////////////////////////////////
		// Get handle over WinAmp process
		DWORD dwWinAmpProcId;
		::GetWindowThreadProcessId(hWnd, &dwWinAmpProcId);
	
		hWinampProc = ::OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ, FALSE, dwWinAmpProcId);
		if(!hWinampProc)
			return false;

		allocEx = (virtAllocEx)::GetProcAddress(hKernel, "VirtualAllocEx");
		if(allocEx == NULL)
			return false;
		freeEx	= (virtFreeEx)::GetProcAddress(hKernel, "VirtualFreeEx");
		if(freeEx == NULL)
			return false;

		///////////////////////////////////////////////////////
		// Allocate the buffers in WinAmp address space
		pExtFileStructRemote = (extendedFileInfoStruct*)allocEx(hWinampProc, NULL, sizeof(extFileStruct), MEM_COMMIT,PAGE_READWRITE);
		if(pExtFileStructRemote == NULL)
			return false;
		pszFileNameRemote = (char*)allocEx(hWinampProc, NULL, strFileName.length() + 1, MEM_COMMIT, PAGE_READWRITE);
		if(pszFileNameRemote == NULL)
			return false;
		pszFieldRemote = (char*)allocEx(hWinampProc, NULL, strField.length() + 1, MEM_COMMIT, PAGE_READWRITE);
		if(pszFieldRemote == NULL)
			return false;
		pszBufferRemote = (char*)allocEx(hWinampProc, NULL, cbSize, MEM_COMMIT, PAGE_READWRITE);
		if(pszBufferRemote == NULL)
			return false;

		// Fill the buffers allocated
		DWORD dwRet;
		if(::WriteProcessMemory(hWinampProc, pszFileNameRemote, (void*)(strFileName.c_str()), strFileName.length() + 1, &dwRet) == 0)
			return false;
		if(::WriteProcessMemory(hWinampProc, pszFieldRemote, (void*)(strField.c_str()), strField.length() + 1, &dwRet) == 0)
			return false;

		extFileStruct.filename	= pszFileNameRemote;
		extFileStruct.metadata	= pszFieldRemote;
		extFileStruct.ret		= pszBufferRemote;
		extFileStruct.retlen	= cbSize;

		if(::WriteProcessMemory(hWinampProc, pExtFileStructRemote, &extFileStruct, sizeof(extFileStruct), &dwRet) == 0)
			return false;

		///////////////////////////////////////////////////////
		// Send request to Winamp
		if(::SendMessage(hWnd, WM_WA_IPC, (WPARAM)pExtFileStructRemote, IPC_GET_EXTENDED_FILE_INFO))
		{
			std::auto_ptr<char> pszBuffer(new char[cbSize + 1]);

			if(pszBuffer.get())
			{
				if(::ReadProcessMemory(hWinampProc, pszBufferRemote, pszBuffer.get(), cbSize, &dwRet) == 0)
					return false;

				metadata = pszBuffer.get();
			}
			else
				return false;
		}

		return true;
	}
	__finally
	{
		// Clean the Winamp address space
		if(pExtFileStructRemote)
			freeEx(hWinampProc, pExtFileStructRemote, 0, MEM_DECOMMIT);
		if(pszFileNameRemote)
			freeEx(hWinampProc, pszFileNameRemote, 0, MEM_DECOMMIT);
		if(pszFieldRemote)
			freeEx(hWinampProc, pszFieldRemote, 0, MEM_DECOMMIT);
		if(pszBufferRemote)
			freeEx(hWinampProc, pszBufferRemote, 0, MEM_DECOMMIT);

		// Close the process
		if(hWinampProc)
			::CloseHandle(hWinampProc);
	}
}
