#include "StdAfx.h"
#include "WinampMonitorPlugin.h"

namespace PluginBase
{
	/// <summary>
	/// vOC^Cv̎擾
	/// </summary>
	PluginType WinampMonitorPlugin::MyPluginType::get()
	{
		return PluginType::AppMonitor;
	}
	
	/// <summary>
	/// vOC̎擾
	/// </summary>
	String^ WinampMonitorPlugin::PluginName::get()
	{
		return L"Winamp App Monitor Plugin Ver1.00";
	}

	/// <summary>
	/// vOC̒쌠̎擾
	/// </summary>
	String^ WinampMonitorPlugin::Copyright::get()
	{
		return L"`m";
	}

	/// <summary>
	/// T|[gv[[̎擾
	/// </summary>
	String^ WinampMonitorPlugin::SupportPlayerName::get()
	{
		return L"Winamp";
	}

	/// <summary>
	/// ݍĐ̋ȏiĐĂȂAȂ擾łȂꍇ nullptrj
	/// </summary>
	TrackInfo^ WinampMonitorPlugin::CurrentTrackInfo::get()
	{
		if(!IsPlaying)
			return nullptr;

		return CreateTrackInfo();
	}

	/// <summary>
	/// j^[𒲂ׂ
	/// </summary>
	bool WinampMonitorPlugin::IsBusy::get()
	{
		return _appMonitorTimer != nullptr;
	}

	/// <summary>
	/// ݍĐ𒲂ׂ
	/// </summary>
	bool WinampMonitorPlugin::IsPlaying::get()
	{
		if(!IsConnected)
			return false;

		return Winamp::IsPlaying();
	}

	/// <summary>
	/// Đʒu̎擾
	/// </summary>
	int WinampMonitorPlugin::PlayerPosition::get()
	{
		if(!IsConnected)
			return 0;

		return Winamp::GetPlayerPosition();
	}

	/// <summary>
	/// Đʒu̐ݒ
	/// </summary>
	void WinampMonitorPlugin::PlayerPosition::set(int value)
	{
		if(!IsConnected)
			return;

		Winamp::SetPlayerPosition(value);
	}

	/// <summary>
	/// Đ{[ 0 ` 100 [%] Ŏ擾
	/// </summary>
	int WinampMonitorPlugin::SoundVolume::get()
	{
		if(!IsConnected)
			return 0;

		return Winamp::GetSoundVolume();
	}

	/// <summary>
	/// Đ{[ 0 ` 100 [%] Őݒ
	/// </summary>
	void WinampMonitorPlugin::SoundVolume::set(int value)
	{
		if(!IsConnected)
			return;

		Winamp::SetSoundVolume(value);
	}

	/// <summary>
	/// Winamp Ƃ̃NmĂ邩𒲂ׂ
	/// </summary>
	bool WinampMonitorPlugin::IsConnected::get()
	{
		return Winamp::FindWinamp() != NULL;
	}


	/// <summary>
	/// j^[Jn܂BɃj^[Jnłꍇ true Ԃ܂B
	/// łɊJnĂꍇ false Ԃ܂B
	/// </summary>
	/// <param name="appMonitorInterval">Ď^C}[Ԋu[ms](^C}[gpȂ̂ȂΖ΂)</param>
	/// <param name="appStopWait">AvP[V̏Iҋ@鎞[ms]i0őҋ@Ȃj</param>
	/// <returns>false sAtrue </returns>
	bool WinampMonitorPlugin::StartMonitor(int appMonitorInterval, int appStopWait)
	{
		try
		{
			if(IsBusy)
				return false;

			_appMonitorInterval = appMonitorInterval;

			if(appStopWait > 0)
			{
				int count = 0;
				while(IsConnected)
				{
					System::Threading::Thread::Sleep(500);
					count += 500;

					if(count >= appStopWait)
						break;
				}
			}

			TimerCallback^ timerDelegate = gcnew TimerCallback(this, &WinampMonitorPlugin::_appMonitorTimer_MonitorTask );
			_appMonitorTimer = gcnew Timer(timerDelegate, this, 1000, _appMonitorInterval);
		}
		catch(Exception^ ex)
		{
			LastException = ex;
			_eventQueue->Push(AppMonitorEvent::PluginErrorEvent);

			return false;
		}

		return true;
	}

	/// <summary>
	/// j^[~܂B
	/// </summary>
	void WinampMonitorPlugin::StopMonitor()
	{
		try
		{
			if(!IsBusy)
				return;

			DisposeTimer();
		}
		catch(Exception^ ex)
		{
			LastException = ex;
			_eventQueue->Push(AppMonitorEvent::PluginErrorEvent);
		}
		finally
		{
			_hysteresisFlag = false;
		}
	}

	/// <summary>
	/// v[𐧌䂵܂
	/// </summary>
	/// <param name="type">^Cv</param>
	/// <returns>false sAtrue </returns>
	bool WinampMonitorPlugin::ControlPlayer(PlayerControl type)
	{
		try
		{
			if(!IsConnected)
				return false;

			switch(type)
			{
			case PlayerControl::Play:
				// ꎞ~Ȃ΃|[Yŉ
				if(Winamp::IsPause())
					Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_PAUSE);
				else
					Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_PLAY);
				break;

			case PlayerControl::Stop:
				Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_PAUSE);
				break;

			case PlayerControl::Next:
				Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_SKIP_NEXT);
				break;

			case PlayerControl::Prev:
				Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_SKIP_BEFORE);

			case PlayerControl::SwitchPlay:
				if(Winamp::IsPlaying())
				{
					Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_PAUSE);
				}
				else
				{
					if(Winamp::IsPause())
						Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_PAUSE);
					else
						Winamp::SendCommandMessase(CTRLWINAMP_COMMAND_PLAY);
				}
				break;

			default:
				return false;
			}
		}
		catch(Exception^ ex)
		{
			LastException = ex;
			_eventQueue->Push(AppMonitorEvent::PluginErrorEvent);

			return false;
		}

		return true;
	}

	/// <summary>
	/// vOC[hɌĂ΂
	/// </summary>
	/// <param name="obj">gp</param>
	void WinampMonitorPlugin::Init(Object^ obj)
	{
		// [hɂłɍĐJnĂꍇ́A̋ȃ^Cg擾
		// (ʒmȂ悤ɂ)
		try
		{
			if(IsPlaying)
			{
				int idx = Winamp::GetPlayListPosition();
				if(idx >= 0)
				{
					String^ title = String::Empty;
					if(GetPlayListFilename(idx, title))
						_currentTrackTitle = title;
				}
			}
		}
		catch(Exception^ ex)
		{
			LastException = ex;
			_eventQueue->Push(AppMonitorEvent::PluginErrorEvent);

			return;
		}
	}

	/// <summary>
	/// vOCIɌĂ΂
	/// </summary>
	/// <param name="obj">gp</param>
	void WinampMonitorPlugin::Exit(Object^ obj)
	{
		DisposeTimer();
	}

	/// <summary>
	/// vOC̐ݒsۂɌĂ΂
	/// </summary>
	/// <param name="obj">gp</param>
	void WinampMonitorPlugin::Config(Object^ obj)
	{
	}

	/// <summary>
	/// j^[Cxg|bv
	/// </summary>
	/// <returns></returns>
	AppMonitorEvent WinampMonitorPlugin::PopAppMonitorEvent()
	{
		AppMonitorEvent appEvent;
		if(_eventQueue->Pop(appEvent))
			return appEvent;

		return AppMonitorEvent::None;
	}

	/// <summary>
	/// RXgN^
	/// </summary>
	WinampMonitorPlugin::WinampMonitorPlugin(void)
	{
	}
	/// <summary>
	/// fXgN^
	/// </summary>
	WinampMonitorPlugin::~WinampMonitorPlugin(void)
	{
		DisposeTimer();
	}
	/// <summary>
	/// t@CiCU
	/// </summary>
	WinampMonitorPlugin::!WinampMonitorPlugin(void)
	{
		DisposeTimer();
	}
	
	/// <summary>
	/// ^C}[ji~j
	/// </summary>
	void WinampMonitorPlugin::DisposeTimer()
	{
		if(_appMonitorTimer != nullptr)
		{
			delete _appMonitorTimer;
			_appMonitorTimer = nullptr;
		}
	}

	/// <summary>
	/// Winamp 猻ݍĐ̃gbN擾
	/// </summary>
	/// <returns></returns>
	TrackInfo^ WinampMonitorPlugin::CreateTrackInfo()
	{
		try
		{
			TrackInfo^ trackInfo = gcnew TrackInfo();

			int pos = Winamp::GetPlayListPosition();
			if(pos < 0)
				return nullptr;

			String^ filepath = String::Empty;
			if(!GetPlayListFilename(pos, filepath))
				return nullptr;

			trackInfo->FilePath = filepath;

			String^ metadata;
			GetMetaDataInfo(filepath, MetaField::Artist, metadata);
			trackInfo->Artist = metadata;
			GetMetaDataInfo(filepath, MetaField::Album, metadata);
			trackInfo->Album = metadata;
			GetMetaDataInfo(filepath, MetaField::TrackName, metadata);
			trackInfo->Name = metadata;
			GetMetaDataInfo(filepath, MetaField::TrackNumber, metadata);
			trackInfo->TrackNo = metadata;

			// Đ
			trackInfo->Duration = Winamp::GetPlayingTrackLength();
			// A[g[N̎擾݂
			trackInfo->ArtworkFilepath = SearchAlbumArt(filepath, trackInfo->Album);

			return trackInfo;
		}
		catch(Exception^ ex)
		{
			LastException = ex;
			_eventQueue->Push(AppMonitorEvent::PluginErrorEvent);
		}

		return nullptr;
	}

	/// <summary>
	// gqςČ
	/// </summary>
	String^ WinampMonitorPlugin::FileExists(String^ baseFilename)
	{
		// gq
		array<String^>^ exts = gcnew array<String^>(4);
		exts[0] = L".jpg";
		exts[1] = L".png";
		exts[2] = L".gif";
		exts[3] = L".bmp";

		for each(String^ ext in exts)
		{
			try
			{
				if(File::Exists(baseFilename + ext))
					return baseFilename + ext;
			}
			catch(Exception^)
			{
				return String::Empty;
			}
		}

		return String::Empty;
	}

	/// <summary>
	/// Winamp ̎dlɂƂăAoA[g
	/// </summary>
	/// <param name="filepath">ȃt@C</param>
	/// <param name="album">AoigpȂꍇ͋󕶎j</param>
	/// <returns>AoA[g̃tpXBȂꍇ͋󕶎B</returns>
	String^ WinampMonitorPlugin::SearchAlbumArt(String^ filepath, String^ album)
	{
		// tH_
		String^ foldername = Path::GetDirectoryName(filepath);

		// t@CŌ
		if(filepath->Length > 0)
		{
			String^ baseFilename = foldername + L"\\" + Path::GetFileNameWithoutExtension(filepath);

			String^ result = FileExists(baseFilename);
			if(result->Length > 0)
				return result;
		}

		// AoŌ
		if(album->Length > 0)
		{
			String^ baseFilename = foldername + L"\\" + album;

			String^ result = FileExists(baseFilename);
			if(result->Length > 0)
				return result;
		}

		// cover Ō
		{
			String^ baseFilename = foldername + L"\\cover";

			String^ result = FileExists(baseFilename);
			if(result->Length > 0)
				return result;
		}

		// folder Ō
		{
			String^ baseFilename = foldername + L"\\folder";

			String^ result = FileExists(baseFilename);
			if(result->Length > 0)
				return result;
		}

		// front Ō
		{
			String^ baseFilename = foldername + L"\\front";

			String^ result = FileExists(baseFilename);
			if(result->Length > 0)
				return result;
		}

		return String::Empty;
	}

	/// <summary>
	/// Winamp N󋵊Ď^C}[Cxg
	/// </summary>
	/// <param name="StateObj"></param>
	void WinampMonitorPlugin::_appMonitorTimer_MonitorTask(System::Object^ StateObj)
	{
		if(_flag)
			return;

		try
		{
			_flag = true;

			// łɐڑmĂꍇ́AĐ̕ωĎ
			if(IsConnected)
			{
				// Đ𒲂ׂ
				if(IsPlaying)
				{
					int idx = Winamp::GetPlayListPosition();
					if(idx >= 0)
					{
						String^ title = String::Empty;
						if(GetPlayListFilename(idx, title))
						{
							if(title != _currentTrackTitle)
							{
								_eventQueue->Push(AppMonitorEvent::ChangePlayingTrack);
								_currentTrackTitle = title;
							}
						}
					}

					_stopFlag = false;
				}
				else
				{
					if(!_stopFlag)
					{
						_eventQueue->Push(AppMonitorEvent::StopPlayingTrack);

						_stopFlag = true;
						_currentTrackTitle = String::Empty;
					}
				}
			}

			// NĂꍇ Winamp ̏ImF܂ŐڑĐڑȂ
			if(_hysteresisFlag)
			{
				if(!IsConnected)
				{
					_eventQueue->Push(AppMonitorEvent::Disconnect);
					_hysteresisFlag = false;
				}
			}
			else
			{
				// Winamp NĂ邩𒲂ׂċNĂꍇ̓N݂
				if(IsConnected)
				{
					_eventQueue->Push(AppMonitorEvent::Connect);
					_hysteresisFlag = true;
				}
			}
		}
		catch(Exception^ ex)
		{
			LastException = ex;
			_eventQueue->Push(AppMonitorEvent::PluginErrorEvent);

			_hysteresisFlag = false;
		}
		finally
		{
			_flag = false;
		}
	}

	/// <summary>
	/// vCXg̃CfbNXw肵āA̋Ȃ̃t@CpX擾
	/// </summary>
	bool WinampMonitorPlugin::GetPlayListFilename(int index, String^ %filepath)
	{
		filepath = String::Empty;

		std::string strFilepath;
		if(!Winamp::GetPlayListFilename(index, strFilepath))
			return false;

		filepath = marshal_as<String^>(strFilepath.c_str());
		return true;
	}

	/// <summary>
	/// ^f[^擾܂
	/// </summary>
	bool WinampMonitorPlugin::GetMetaDataInfo(String^ filepath, MetaField field, String^ %metadata)
	{
		metadata = String::Empty;

		marshal_context^ context = gcnew marshal_context();
		std::string strFilepath = context->marshal_as<const char*>(filepath);	

		std::string strMetadata;
		if(!Winamp::GetMetaDataInfo(strFilepath, static_cast<METAFIELD>(field), strMetadata))
			return false;

		metadata = marshal_as<String^>(strMetadata.c_str());
		return true;
	}
}