#pragma once

#include <string>
#include "Winamp.h"

#include <msclr/marshal.h>

using namespace System;
using namespace System::Threading;
using namespace System::IO;
using namespace System::Runtime::InteropServices;
using namespace msclr::interop;

namespace PluginBase
{
	/// <summary>
	/// Winampj^[vOCNX
	/// </summary>
	public ref class WinampMonitorPlugin : MarshalByRefObject, IAppMonitorPlugin
	{
	private:
		/// <summary>
		/// ^f[^tB[h񋓎q
		/// </summary>
		enum class MetaField
		{
			/// <summary>
			/// gbN
			/// </summary>
			TrackName = METAFIELD_TRACKNAME,
			/// <summary>
			/// Ao
			/// </summary>
			Album = METAFIELD_ALBUM,
			/// <summary>
			/// A[eBXg
			/// </summary>
			Artist = METAFIELD_ARTIST,
			/// <summary>
			/// N
			/// </summary>
			Year = METAFIELD_YEAR,
			/// <summary>
			/// W
			/// </summary>
			Genre = METAFIELD_GENRE,
			/// <summary>
			/// gbNԍ
			/// </summary>
			TrackNumber = METAFIELD_TRACKNUMBER,
			/// <summary>
			/// 
			/// </summary>
			Length = METAFIELD_LENGTH,
			/// <summary>
			/// Rg
			/// </summary>
			Comment = METAFIELD_COMMENT,
		};

	public:
		/// <summary>
		/// [XԂ̏
		/// </summary>
		/// <returns></returns>
		virtual Object^ InitializeLifetimeService() override
		{
			return nullptr;
		}

	private:
		/// <summary>
		/// Winamp ɐڑς݂ꍇ true(N댟õqXeVXptO)
		/// </summary>
		static bool _hysteresisFlag = false;
		/// <summary>
		/// Winamp N󋵊Ď^C}[
		/// </summary>
		static Timer^ _appMonitorTimer = nullptr;
		/// <summary>
		/// Winamp N󋵊Ď^C}[Ԋu[ms]
		/// </summary>
		int _appMonitorInterval;

		/// <summary>
		/// CxgL[
		/// </summary>
		static EventQueue<AppMonitorEvent>^ _eventQueue = gcnew EventQueue<AppMonitorEvent>();

		/// <summary>
		/// dsh~tO
		/// </summary>
		static bool _flag = false;
		/// <summary>
		/// ĐȕύXĎp^CgWX^
		/// </summary>
		static String^ _currentTrackTitle = L"";
		/// <summary>
		/// ~Cxg̑dMh~tO
		/// </summary>
		static bool _stopFlag = true;

	public:
		/// <summary>
		/// vOC^Cv̎擾
		/// </summary>
		virtual property PluginType MyPluginType { PluginType get(); }
		/// <summary>
		/// vOC̎擾
		/// </summary>
		virtual property String^ PluginName { String^ get(); }
		/// <summary>
		/// vOC̒쌠̎擾
		/// </summary>
		virtual property String^ Copyright { String^ get(); }
		/// <summary>
		/// T|[gv[[̎擾
		/// </summary>
		virtual property String^ SupportPlayerName { String^ get(); }
		/// <summary>
		/// ݍĐ̋ȏiĐĂȂAȂ擾łȂꍇ nullptrj
		/// </summary>
		virtual property TrackInfo^ CurrentTrackInfo { TrackInfo^ get(); }
		/// <summary>
		/// j^[𒲂ׂ
		/// </summary>
		virtual property bool IsBusy { bool get(); }
		/// <summary>
		/// ݍĐ𒲂ׂ
		/// </summary>
		virtual property bool IsPlaying { bool get(); }
		/// <summary>
		/// Đʒu̎擾Aݒ
		/// </summary>
		virtual property int PlayerPosition { int get(); void set(int); }
		/// <summary>
		/// Đ{[ 0 ` 100 [%] Ŏ擾Aݒ
		/// </summary>
		virtual property int SoundVolume { int get(); void set(int); }
		/// <summary>
		/// Winamp Ƃ̃NmĂ邩𒲂ׂ
		/// </summary>
		virtual property bool IsConnected { bool get(); }
		/// <summary>
		/// Ō̃G[Ԃi1G[ĂȂƂ nullptrj
		/// </summary>
		virtual property Exception^ LastException;

	public:
		/// <summary>
		/// j^[Jn܂BɃj^[Jnłꍇ true Ԃ܂B
		/// łɊJnĂꍇ false Ԃ܂B
		/// </summary>
		/// <param name="appMonitorInterval">Ď^C}[Ԋu[ms](^C}[gpȂ̂ȂΖ΂)</param>
		/// <param name="appStopWait">AvP[V̏Iҋ@鎞[ms]i0őҋ@Ȃj</param>
		/// <returns>false sAtrue </returns>
		virtual bool StartMonitor(int appMonitorInterval, int appStopWait);

		/// <summary>
		/// j^[~܂B
		/// </summary>
		virtual void StopMonitor();

		/// <summary>
		/// v[𐧌䂵܂
		/// </summary>
		/// <param name="type">^Cv</param>
		/// <returns>false sAtrue </returns>
		virtual bool ControlPlayer(PlayerControl type);

		/// <summary>
		/// vOC[hɌĂ΂
		/// </summary>
		/// <param name="obj">gp</param>
		virtual void Init(Object^ obj);

		/// <summary>
		/// vOCIɌĂ΂
		/// </summary>
		/// <param name="obj">gp</param>
		virtual void Exit(Object^ obj);

		/// <summary>
		/// vOC̐ݒsۂɌĂ΂
		/// </summary>
		/// <param name="obj">gp</param>
		virtual void Config(Object^ obj);

		/// <summary>
		/// j^[Cxg|bv
		/// </summary>
		/// <returns></returns>
		virtual AppMonitorEvent PopAppMonitorEvent();

	public:
		WinampMonitorPlugin(void);
		~WinampMonitorPlugin(void);
		!WinampMonitorPlugin(void);
	
	private:
		/// <summary>
		/// ^C}[ji~j
		/// </summary>
		void DisposeTimer();

		/// <summary>
		/// Winamp 猻ݍĐ̃gbN擾
		/// </summary>
		/// <returns></returns>
		TrackInfo^ CreateTrackInfo();

		/// <summary>
		// gqςČ
		/// </summary>
		static String^ FileExists(String^ baseFilename);

		/// <summary>
		/// Winamp ̎dlɂƂăAoA[g
		/// </summary>
		/// <param name="filepath">ȃt@C</param>
		/// <param name="album">AoigpȂꍇ͋󕶎j</param>
		/// <returns>AoA[g̃tpXBȂꍇ͋󕶎B</returns>
		static String^ SearchAlbumArt(String^ filepath, String^ album);

		/// <summary>
		/// Winamp N󋵊Ď^C}[Cxg
		/// </summary>
		/// <param name="StateObj"></param>
		void _appMonitorTimer_MonitorTask(System::Object^ StateObj);

		/// <summary>
		/// vCXg̃CfbNXw肵āA̋Ȃ̃t@CpX擾
		/// </summary>
		bool GetPlayListFilename(int index, [Runtime::InteropServices::Out]String^ %filepath);

		/// <summary>
		/// ^f[^擾܂
		/// </summary>
		bool GetMetaDataInfo(String^ filepath, MetaField field, [Runtime::InteropServices::Out]String^ %metadata);
	};
	
	/// <summary>
	/// VOĝ߂̃wp[NX
	/// </summary>
	public ref class SingletonHelper : SingletonHelperBase<WinampMonitorPlugin^>
	{
	};
}